#!/usr/bin/env python
#encoding: utf-8

"""
 DGX-660B
 kdyz se přepne MK249C na kanal 16, tak to prepina tyto rejstriky, ktere jsou nize definovane, jinak to jen preposila signaly, aniz by je modifikovalo.
 Vsechy vstupni signaly se prevadi na 1-3 kanal.
 Kdyz se na kanale 16 zapne nástroj 11, mididings zapne akordeon.
 Kdyz se na jinem kanale nez 16 zapne nastroj 11, zacne hrat 11. nastroj podle General midi, tzn. Vibrafon.
 Kdyz pripojim pres Raspberry masterkeybord k Yamaze DGX-660B, pak zkopiruji soubor:
	cp mididings_DGX-660B.py midigins.py
 Po restartu to hraje podle rejstriku tohoto nastroje.
 Pokud mate jiny nastroj, musite si precist v UserGuide, jak se to nastavuje ve Vasem pripade.
 Vetsinou to exportuji z PDF do textu se zachovanim layoutu.
	pdftotext -layout userguide.pdf userguide.txt
 Pak to prevedu do Calc (Excel) a nasledujici radky vytvorim vzorcem.
	Viz soubor rejstriky_DGX-660B.ods nebo rejstriky_YPT-230.ods

"""
from mididings import *


run(
    scenes = {
1:	Scene("Natural! Grand Piano", Channel(1) >> Pass(), Ctrl(1, 1, 0,108) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 1 )),
2:	Scene("Ambient Grand Piano", Channel(1) >> Pass(), Ctrl(1, 1, 0,108) >> Ctrl(1, 1, 32, 28) >> Program(1, 1, 1 )),
3:	Scene("Honky Tonk Piano", Channel(1) >> Pass(), Ctrl(1, 1, 0,108) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 4 )),
4:	Scene("Harpsichord", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 7 )),
5:	Scene("Harpsichord 1", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 7 )),
6:	Scene("Harp", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 47 )),
7:	Scene("70s Percussive Organ", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 24) >> Program(1, 1, 18 )),
8:	Scene("Chapel Organ", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 113) >> Program(1, 1, 20 )),
9:	Scene("Jazz Organ 1", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 17 )),
10:	Scene("Rock Organ", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 19 )),
11:	Scene("Traditional Accordion", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 113) >> Program(1, 1, 22 )),
12:	Scene("Finger Bass", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 34 )),
13:	Scene("Jazz Rhythm", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 40) >> Program(1, 1, 33 )),
14:	Scene("Vox Humana", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 54 )),
15:	Scene("Choir", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 53 )),
16:	Scene("String Ensemble", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 49 )),
17:	Scene("Insomnia", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 113) >> Program(1, 1, 95 )),
18:	Scene("Warm Strings", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 40) >> Program(1, 1, 50 )),
19:	Scene("Choir Strings", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 40) >> Program(1, 1, 53 )),
20:	Scene("Nylon Guitar", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 25 )),
21:	Scene("Clean Guitar", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 28 )),
22:	Scene("Blues Guitar", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 119) >> Program(1, 1, 27 )),
23:	Scene("Overdriven Guitar", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 30 )),
24:	Scene("French Horn", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 61 )),
25:	Scene("Tenor Sax", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 67 )),
26:	Scene("Oboe", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 69 )),
27:	Scene("English Horn", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 70 )),
28:	Scene("Bassoon", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 71 )),
29:	Scene("Flute", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 74 )),
30:	Scene("Ocarina", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 80 )),
31:	Scene("Warm Pad", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 90 )),
32:	Scene("Bass & Lead", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 88 )),
33:	Scene("New Age Pad", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 89 )),
34:	Scene("Vibraphone", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 12 )),
35:	Scene("Tubular Bells", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 15 )),
36:	Scene("Timpani", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 48 )),
37:	Scene("Tinkle Bell", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 113 )),
38:	Scene("Orchestra Hit", Channel(1) >> Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 56 )),
39:	Scene("Standard Kit 1", Channel(1) >> Pass(), Ctrl(1, 1, 0,127) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 1 )),

112:	Scene("Panic!", # pozor je to o cislo vys, nez jak se to rozbrazuje
			Pass(),
			#Ctrl(port, channel, ctrl, value)
			# napred si v pre nastavi rejstriky na 2.a 3. kanal a pak prichozi noty splituje do jednotlivych kanalu, podle vyse noty.
			Panic(True)
			),
128:	Scene("split piano/bass",
			KeySplit('f#2', Channel(2),Channel(3)), #f#2 včetně jde nahoru
			#Ctrl(port, channel, ctrl, value)
			# napred si v pre nastavi rejstriky na 2.a 3. kanal a pak prichozi noty splituje do jednotlivych kanalu, podle vyse noty.
			[Ctrl(1, 3, 0,108) 	>> Ctrl(1, 3, 32, 0) 	>> Program(1, 3, 1  ), #piano
			 Ctrl(1, 2, 0,0) 	>> Ctrl(1, 2, 32, 112) 	>> Program(1, 2, 34 )] #bass
			),
127:	Scene("split piano+housle/bass",
			KeySplit('f#2', Channel(2),[Channel(3),Channel(4)]), #f#2 včetně jde nahoru
			#Ctrl(port, channel, ctrl, value)
			[Ctrl(1, 4, 0,0) 	>> Ctrl(1, 4, 32, 40) 	>> Program(1, 4, 50 ),	#housle
			 Ctrl(1, 3, 0,108) 	>> Ctrl(1, 3, 32, 0) 	>> Program(1, 3, 1  ),	#piano
			 Ctrl(1, 2, 0,0) 	>> Ctrl(1, 2, 32, 112) 	>> Program(1, 2, 34 )]	#bass
			),
126:	Scene("split vibrafone/bass",
			KeySplit('f#2', Channel(2),Channel(3)), #f#2 včetně jde nahoru
			#Ctrl(port, channel, ctrl, value)
			# napred si v pre nastavi rejstriky na 2.a 3. kanal a pak prichozi noty splituje do jednotlivych kanalu, podle vyse noty.
			[Ctrl(1, 3, 0,0) 	>> Ctrl(1, 3, 32, 112) 	>> Program(1, 3, 12 ), #vibrafone
			 Ctrl(1, 2, 0,0) 	>> Ctrl(1, 2, 32, 112) 	>> Program(1, 2, 34 )] #bass
			),
125:	Scene("Mixtura", Pass() // Transpose(7) // Transpose(12)), #ProgramFilter(program, ...)
124:	Scene("split hluboky/vysoky housle",
		   Channel(1) >> KeySplit('f3', Transpose(-12) ,Pass()),
		   Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 49 )
		   ),
123:	Scene("split hluboky/vysoky", KeySplit('c3', Transpose(-12) ,Transpose(12) )),
    }, #toto je konec scenes={}
    #control =  Filter(PROGRAM) >> SceneSwitch(), #~Filter(CTRL) >>
    #pre = ~Filter(PROGRAM),
    control =  ChannelSplit({(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15): Filter(CTRL|PROGRAM), (16):Channel(1) >> Filter(PROGRAM) >> SceneSwitch()}),
    pre = ~Filter(PROGRAM) >> ~ChannelFilter(15)
    #pre = ~Filter(PROGRAM) >> ~ChannelFilter(15)
	#Print(string=...) # vypise cokoli

)
